
#ifdef HAVE_CONFIG_H
#include <config.h>
#endif

#include <SDL/SDL.h>
#include "../emu.h"
#include "../screen.h"
#include "../video.h"
#include "../effect.h"
#include "../conf.h"

static SDL_Rect buf_rect	 =	{16, 16, 304, 224};
static SDL_Rect screen_rect =	{ 0,  0, 304, 224};
static SDL_Surface *offscreen;

SDL_bool
blitter_soft_init()
{
	Uint32 width = 304;
	Uint32 height = 224;
	int hw_surface=(CF_BOOL(cf_get_item_by_name("hwsurface"))?SDL_HWSURFACE:SDL_SWSURFACE);
	Uint32 sdl_flags = hw_surface|(fullscreen?SDL_FULLSCREEN:0);
	
	if (scale == 1) {
	    width *=effect[neffect].x_ratio;
	    height*=effect[neffect].y_ratio;
	} else {
	    width *=2;
	    height *=2;
	}
	
		
	screen = SDL_SetVideoMode(width, height, 16, sdl_flags);
	if (!screen) return SDL_FALSE;
	//offscreen = SDL_CreateRGBSurface(SDL_HWSURFACE, 304, 224, 16, 0xF800, 0x7E0, 0x1F, 0);

	return SDL_TRUE;
}

void 
update_double()
{
	Uint16 *src, *dst;
	Uint32 s, d;
	Uint8 w, h;
	
	(Uint16 *)src = (Uint16 *)buffer->pixels + 16 + (336 << 4);// LeftBorder + RowLength * UpperBorder
	(Uint16 *)dst = (Uint16 *)screen->pixels;
	
	for(h = 224; h > 0; h--)
	{
		for(w = 152; w > 0; w--)
		{		
			s = *(Uint32 *)src;
#ifdef WORDS_BIGENDIAN
			d = (s & 0xFFFF0000) + ((s & 0xFFFF0000)>>16);
			*(Uint32 *)(dst) = d;
			*(Uint32 *)(dst+608) = d;
				
			d = (s & 0x0000FFFF) + ((s & 0x0000FFFF)<<16);
			*(Uint32 *)(dst+2) = d;
			*(Uint32 *)(dst+610) = d;
#else				
			d = (s & 0xFFFF0000) + ((s & 0xFFFF0000)>>16);
			*(Uint32 *)(dst+2) = d;
			*(Uint32 *)(dst+610) = d;
				
			d = (s & 0x0000FFFF) + ((s & 0x0000FFFF)<<16);
			*(Uint32 *)(dst) = d;
			*(Uint32 *)(dst+608) = d;
#endif			
			dst += 4;
			src += 2;
		}
		src += 32;		
		dst += 608;
	}
}

void
blitter_soft_update()
{
    int i;
  if (neffect == 0) {
    if (scale > 1)
      update_double();
    else {
	SDL_BlitSurface(buffer, &buf_rect, screen, &screen_rect);
    }

  }
  SDL_UpdateRect(screen, 0, 0, 0, 0);
 
}

void
blitter_soft_close(){}
	
void
blitter_soft_fullscreen() {
  SDL_WM_ToggleFullScreen(screen);
}
	
