
#ifdef HAVE_CONFIG_H
#include <config.h>
#endif

#include <stdlib.h>
#include <SDL/SDL.h>
#include "../screen.h"
#include "../video.h"

extern void Init_2xSaIMMX(Uint32 bitformat);
extern void _2xSaILine(Uint8 *srcPtr, Uint8 *deltaPtr, Uint32 srcPitch, Uint32 width,
                       Uint32 dstOffset, Uint32 dstPitch, Uint16 dstSegment);

extern void _2xSaISuper2xSaILine(Uint8 *srcPtr, Uint8 *deltaPtr, Uint32 srcPitch, Uint32 width,
                       Uint32 dstOffset, Uint32 dstPitch, Uint16 dstSegment);

extern void _2xSaISuperEagleLine(Uint8 *srcPtr, Uint8 *deltaPtr, Uint32 srcPitch, Uint32 width,
                       Uint32 dstOffset, Uint32 dstPitch, Uint16 dstSegment);

static Uint8 *deltaptr;

SDL_bool
effect_sai_init()
{
	Init_2xSaIMMX(565);
	deltaptr = (Uint8*)malloc(336*256*2);
	
	return SDL_TRUE;
}


void
effect_sai_update()
{	
	Uint8 *src = buffer->pixels + 337*16*2;
	Uint8 *dst = screen->pixels;
	Uint8 *dptr = deltaptr;
		
	Uint8 height = 224;			
	
	while(height--)
	{
	/* Params:
		1: Source pixmap
	   2: buffer(same size of source visible area)
		3: Src row bytes
		4: Src length(not in bytes)
		5: Destination source
		6: Destination row bytes
		7: ? only use with djgpp.
	*/
		_2xSaILine(src, dptr, 336*2, 304, (Uint32)dst, 608*2, 0);
		
		dst += 608*4;
		src += 336*2;
		dptr+= 336*4;
	}						
}

void
effect_supersai_update()
{	
	Uint8 *src = buffer->pixels + 337*16*2;
	Uint8 *dst = screen->pixels;
	Uint8 *dptr = deltaptr;
		
	Uint8 height = 224;			
	
	while(height--)
	{
	/* Params:
		1: Source pixmap
	   2: buffer(same size of source visible area)
		3: Src row bytes
		4: Src length(not in bytes)
		5: Destination source
		6: Destination row bytes
		7: ? only use with djgpp.
	*/
		_2xSaISuper2xSaILine(src, dptr, 336*2, 304, (Uint32)dst, 608*2, 0);
		
		dst += 608*4;
		src += 336*2;
		dptr+= 336*4;
	}						
}

void
effect_eagle_update()
{	
	Uint8 *src = buffer->pixels + 337*16*2;
	Uint8 *dst = screen->pixels;
	Uint8 *dptr = deltaptr;
		
	Uint8 height = 224;			
	
	while(height--)
	{
	/* Params:
		1: Source pixmap
	   2: buffer(same size of source visible area)
		3: Src row bytes
		4: Src length(not in bytes)
		5: Destination source
		6: Destination row bytes
		7: ? only use with djgpp.
	*/
		
		_2xSaISuperEagleLine(src, dptr, 336*2, 304, (Uint32)dst, 608*2, 0);
		
		dst += 608*4;
		src += 336*2;
		dptr+= 336*4;
	}						
}
